## llvm-toolchain-rocm 7.1.0+dfsg

=== debian/changelog ===
llvm-toolchain-rocm (7.1.0+dfsg-1) unstable; urgency=medium

  * Debian build 

 -- Christian Bayle <bayle@debian.org>  Sat, 15 Nov 2025 13:23:34 +0100

llvm-toolchain-rocm (7.1.0+dfsg-0ubuntu1~ppa1) questing; urgency=medium

  * Import new upstream version 7.1.0
  * Bump LLVM base version to 20
    - d/r: bump LLVM major number and .so filename
    - d/p/0010-fixing-rocm-path.patch: update hardcoded path
    - d/rocm-device-libs.install.in: use @LLVM_VERSION@ instead of hardcoded version
  * Fix patches after update to v7.1.0
    - Drop d/p/0002-Remove-err_drv_duplicate_config-check.patch
    - Drop d/p/0003-replace-use-of-mktemp-with-mkstemp.patch
    - Drop d/p/0014-fixing-signature-ConstantFoldFP128.patch
    - Update d/p/0015-remove-env-shebangs.patch with removed files
    - Other changes only remove patch fuzz
  * Add libc folder back to packaging
    - d/copyright: remove libc/ from Excluded-Files list
    - libc/: needed for some shared headers
  * Remove old tools from .install files
    - Drop clang-rename, clang-pseudo scripts
    - Drop hipcc.pl and hipconfig.pl (no-suffix versions still there)
  * Add new tools to .install files
    - clang-rocm: amdclang*, amdflang*, amdllvm
    - lld-rocm: amdlld
    - clang-tools-rocm: clang-sycl-linker
    - libclang-common-rocm-dev: include/llvm_offload_wrappers/*.h
    - llvm-rocm: llvm-cgdata
    - llvm-rocm-tools: llvm-ctxprof-util

 -- Gabriel B. Sant'Anna <gabriel.santanna@canonical.com>  Tue, 11 Nov 2025 14:23:40 -0300

llvm-toolchain-rocm (6.4.3+dfsg-0ubuntu2) questing; urgency=medium

  * d/control, d/hipcc-rocm.install: rename bin:hipcc to bin:hipcc-rocm
  * d/control, d/libamd-comgr*in: add rocm suffix to libamd-comgr package names
  * d/control: hipcc-rocm needs to depend on libamdhip64-dev. This dependency
    exists on bin:hipcc from src:rocm-llvm already.
  * d/rules: calculate number of build jobs dynamically
  * d/t/control: test depends on hipcc-rocm
  * d/t/clang.sh: use rocm clang

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 09 Oct 2025 09:04:52 -0300

llvm-toolchain-rocm (6.4.3+dfsg-0ubuntu1) questing; urgency=medium

  [ Igor Luppi ]
  * New upstream version 6.4.3 (no changes needed)
  
  [ Tim Flink ]
  * forcing comgr to be statically linked

 -- Igor Luppi <igor.luppi@canonical.com>  Fri, 03 Oct 2025 16:52:05 -0300

llvm-toolchain-rocm (6.4.2+dfsg-2ubuntu1) questing; urgency=medium

  * debian: run wrap-and-sort
  * d/{control, rocm-device-libs}: rename the source package
  * d/control: fix Original-Maintainer
  * d/control: update maintainer to ubuntu

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Mon, 22 Sep 2025 07:08:25 +0000

rocm-llvm (6.4.2+dfsg-2) questing; urgency=medium

  * fixing install paths that were installing include files to system llvm
    location

 -- Tim Flink <tflink@tirfa.com>  Mon, 8 Aug 2025 18:44:28 -0600

rocm-llvm (6.4.2+dfsg-1) questing; urgency=medium

  * changed maintainer to reflect change in usage, may need to change again
  * update to upstream 6.4.2
  * rebase patches to work with new version

 -- Tim Flink <tflink@tirfa.com>  Tue, 29 Jul 2025 16:24:18 -0600

rocm-llvm (6.4.1+dfsg-1) questing; urgency=medium

  * build for ubuntu 25.10

 -- Tim Flink <tflink@tirfa.com>  Fri, 18 Jul 2025 13:18:00 -0600

rocm-llvm (6.4.1+dfsg-1~exp1) experimental; urgency=medium

  * updated to upstream 6.4.1
  * updated Files-Excluded

 -- Tim Flink <tflink@tirfa.com>  Thu, 19 Jun 2025 11:17:00 -0600

rocm-llvm (6.4.0-1~exp1) experimental; urgency=medium

  * updated to upstream 6.4.0
  * restored complete source tree
  * imported patches from Fedora as appropriate

 -- Tim Flink <tflink@tirfa.com>  Wed, 21 May 2025 16:05:17 -0600

rocm-llvm (6.1.2+dfsg-1~exp1) experimental; urgency=medium

  [ Xuanteng Huang ]
  * New upstream 6.1.2
    - This replaces all of src:rocm-compilersupport as well as the compiler
      components of src:rocm-hipamd.
  * Reorganize code layout, strip LLVM code forked by AMD
  * Borrow patch from rocm-hipamd to keep the include path order for hipcc
  * Migrate tests from rocm-hipamd as well to validate HIP code compilation
  * Enable Salsa CI pipeline

 -- Xuanteng Huang <xuanteng.huang@outlook.com>  Tue, 22 Oct 2024 23:36:16 +0200
