=== debian/tests/control ===
Tests: hipcc.sh,
       clang.sh,
       hipconfig.sh,
       gcc.sh,
       g++.sh,
Depends: cmake,
         g++,
         gcc,
         hipcc-rocm (>= 6.1.2~),
         libamdhip64-dev (>= 5.7.1),
         make,
         rocminfo (>= 6.1.2~)
Restrictions: superficial, skippable
